#include <avr/io.h>
#include <avr/interrupt.h>
#include <util/delay.h>


// Initialisiere Timer1
void timer1_init (uint16_t freq) 
{ 
    // CTC-Modus, Prescaler=1 
    TCCR1A = 0; 
    TCCR1B = (1 << WGM12) | (1 << CS10); 

    // OutputCompare1A Register setzen 
    
	//Berechnungsformel ursprnglich:
	OCR1A = (uint16_t) ((uint32_t) F_CPU / (2*freq) -1); 
	
	//manuell:
	//OCR1A =  512;
	/* Problem: SOllte fr OCR=512 eine frequenz von 7,185kHz haben, hat aber gemessene 21,559 kHZ*/
	
    // OutputCompare1A Interrupt aktivieren 
    TIMSK |= (1 << OCIE1A); 
} 

//Sollte eigentlich mit der berechneten Frequenz ausgefhrt werden, aber reale Freq ist um den Faktor 3 Grer
SIGNAL(SIG_OUTPUT_COMPARE1A) 
{ 
    PORTD ^= (1<<PD7); 
} 



int main( void )
{
DDRD = 0xff; //Ganzer Port als Ausgang
PORTD = 0x00; //Alle aus;


timer1_init (10000); 
  
sei();
  
for(;;){
       
	   _delay_ms(20);

   
  }
} 


